---
title: BigInt
slug: Web/JavaScript/Reference/Global_Objects/BigInt
tags:
  - BigInt
  - Class
  - JavaScript
  - Reference
---
<div>{{JSRef}}</div>

<p><strong><code>BigInt</code></strong> is a built-in object that provides a way to represent whole numbers larger than 2<sup>53</sup> - 1, which is the largest number JavaScript can reliably represent with the <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Number"><code>Number</code></a> {{Glossary("Primitive", "primitive")}} and represented by the <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Number/MAX_SAFE_INTEGER"><code>Number.MAX_SAFE_INTEGER</code></a> constant. <strong><code>BigInt</code></strong> can be used for arbitrarily large integers.</p>

<h2 id="Description">Description</h2>

<p>A <code>BigInt</code> is created by appending <code>n</code> to the end of an integer literal — <code>10n</code> — or by calling the function <code>BigInt()</code>.</p>

<pre class="brush: js notranslate">const previouslyMaxSafeInteger = 9007199254740991n

const alsoHuge = BigInt(9007199254740991)
// ↪ 9007199254740991n

const hugeString = BigInt("9007199254740991")
// ↪ 9007199254740991n

const hugeHex = BigInt("0x1fffffffffffff")
// ↪ 9007199254740991n

const hugeOctal = BigInt("0o377777777777777777")
// ↪ 9007199254740991n

const hugeBin = BigInt("0b11111111111111111111111111111111111111111111111111111")
// ↪ 9007199254740991n
</pre>

<p><code>BigInt</code> is similar to <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Number"><code>Number</code></a> in some ways, but also differs in a few key matters — it cannot be used with methods in the built-in <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Math"><code>Math</code></a> object and cannot be mixed with instances of <code>Number</code> in operations; they must be coerced to the same type. Be careful coercing values back and forth, however, as the precision of a <code>BigInt</code> may be lost when it is coerced to a <code>Number</code>.</p>

<h3 id="Type_information">Type information</h3>

<p>When tested against <code>typeof</code>, a <code>BigInt</code> will give "bigint":</p>

<pre class="brush: js notranslate">typeof 1n === 'bigint'           // true
typeof BigInt('1') === 'bigint'  // true
</pre>

<p>When wrapped in an <code>Object</code>, a <code>BigInt</code> will be considered as a normal "object" type:</p>

<pre class="brush: js notranslate">typeof Object(1n) === 'object'  // true
</pre>

<h3 id="Operators">Operators</h3>

<p>The following operators may be used with <code>BigInt</code>s (or object-wrapped <code>BigInt</code>s): <code>+</code>, <code>*</code>, <code>-</code>, <code>**</code>, <code>%</code>.</p>

<p><a href="/en-US/docs/Web/JavaScript/Reference/Operators/Bitwise_Operators">Bitwise operators</a> are supported as well, except <code>&gt;&gt;&gt;</code> (zero-fill right shift) as all BigInts are signed.</p>

<p>Also unsupported is the unary operator (<code>+</code>), <a href="https://github.com/tc39/proposal-bigint/blob/master/ADVANCED.md#dont-break-asmjs">in order to not break asm.js</a>.</p>

<pre class="brush: js notranslate">const previousMaxSafe = BigInt(Number.MAX_SAFE_INTEGER)
// ↪ 9007199254740991n

const maxPlusOne = previousMaxSafe + 1n
// ↪ 9007199254740992n

const theFuture = previousMaxSafe + 2n
// ↪ 9007199254740993n, this works now!

const multi = previousMaxSafe * 2n
// ↪ 18014398509481982n

const subtr = multi – 10n
// ↪ 18014398509481972n

const mod = multi % 10n
// ↪ 2n

const bigN = 2n ** 54n
// ↪ 18014398509481984n

bigN * -1n
// ↪ –18014398509481984n
</pre>

<p>The <code>/</code> operator also works as expected with whole numbers.</p>

<p>However, since these are <code>BigInt</code>s and not <code>BigDecimal</code>s, this operation will round towards <code>0</code> (which is to say, it will not return any fractional digits).</p>

<div class="notecard warning">
<p>An operation with a fractional result will be truncated when used with a <code>BigInt</code>.</p>
</div>

<pre class="brush: js notranslate">const expected = 4n / 2n
// ↪ 2n

const rounded = 5n / 2n
// ↪ 2n, not 2.5n

</pre>

<h3 id="Comparisons">Comparisons</h3>

<p>A <code>BigInt</code> is not strictly equal to a <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Number"><code>Number</code></a>, but it <em>is</em> loosely so:</p>

<pre class="brush: js notranslate">0n === 0
// ↪ false

0n == 0
// ↪ true</pre>

<p>A <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Number"><code>Number</code></a> and a <code>BigInt</code> may be compared as usual:</p>

<pre class="brush: js notranslate">1n &lt; 2
// ↪ true

2n &gt; 1
// ↪ true

2 &gt; 2
// ↪ false

2n &gt; 2
// ↪ false

2n &gt;= 2
// ↪ true</pre>

<p>They may be mixed in arrays and sorted:</p>

<pre class="brush: js notranslate">const mixed = [4n, 6, -12n, 10, 4, 0, 0n]
// ↪  [4n, 6, -12n, 10, 4, 0, 0n]

mixed.sort() // default sorting behavior
// ↪  [ -12n, 0, 0n, 10, 4n, 4, 6 ]

mixed.sort((a, b) =&gt; a - b)
// won't work since subtraction will not work with mixed types
// TypeError: can't convert BigInt to number

// sort with an appropriate numeric comparator
mixed.sort((a, b) =&gt; (a &lt; b) ? -1 : ((a &gt; b) ? 1 : 0))
// ↪  [ -12n, 0, 0n, 4n, 4, 6, 10 ]
</pre>

<p>Note that comparisons with <code>Object</code>-wrapped <code>BigInt</code>s act as with other objects, only indicating equality when the same object instance is compared:</p>

<pre class="brush: js notranslate">0n === Object(0n)          // false
Object(0n) === Object(0n)  // false

const o = Object(0n)
o === o                    // true
</pre>

<h3 id="Conditionals">Conditionals</h3>

<p>A <code>BigInt</code> behaves like a <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Number"><code>Number</code></a> in cases where:</p>

<ul>
 <li>it is converted to a <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Boolean"><code>Boolean</code></a>: via the <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Boolean"><code>Boolean</code></a> function;</li>
 <li>when used with <a href="/en-US/docs/Web/JavaScript/Reference/Operators/Logical_Operators">logical operators</a> <code>||</code>, <code>&amp;&amp;</code>, and <code>!</code>; or</li>
 <li>within a conditional test like an <a href="/en-US/docs/Web/JavaScript/Reference/Statements/if...else"><code>if</code></a> statement.</li>
</ul>

<pre class="brush: js notranslate">if (0n) {
  console.log('Hello from the if!')
} else {
  console.log('Hello from the else!')
}

// ↪ "Hello from the else!"

0n || 12n
// ↪ 12n

0n &amp;&amp; 12n
// ↪ 0n

Boolean(0n)
// ↪ false

Boolean(12n)
// ↪ true

!12n
// ↪ false

!0n
// ↪ true
</pre>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/BigInt/BigInt"><code>BigInt()</code></a></dt>
 <dd>Creates a new <code>bigint</code> value.</dd>
</dl>

<h2 id="Static_methods">Static methods</h2>

<dl>
 <dt><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/BigInt/asIntN"><code>BigInt.asIntN()</code></a></dt>
 <dd>Wraps a <code>BigInt</code> value to a signed integer between <code>-2<var><sup>width</sup></var><sup>-1</sup></code> and <code>2<var><sup>width</sup></var><sup>-1</sup> - 1</code>.</dd>
 <dt><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/BigInt/asUintN"><code>BigInt.asUintN()</code></a></dt>
 <dd>Wraps a <code>BigInt</code> value to an unsigned integer between <code>0</code> and <code>2<var><sup>width</sup></var> - 1</code>.</dd>
</dl>

<h2 id="Instance_methods">Instance methods</h2>

<dl>
 <dt><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/BigInt/toLocaleString"><code>BigInt.prototype.toLocaleString()</code></a></dt>
 <dd>Returns a string with a language-sensitive representation of this number. Overrides the <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/toLocaleString"><code>Object.prototype.toLocaleString()</code></a> method.</dd>
 <dt><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/BigInt/toString"><code>BigInt.prototype.toString()</code></a></dt>
 <dd>Returns a string representing the specified object in the specified radix (base). Overrides the <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/toString"><code>Object.prototype.toString()</code></a> method.</dd>
 <dt><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/BigInt/valueOf"><code>BigInt.prototype.valueOf()</code></a></dt>
 <dd>Returns the primitive value of the specified object. Overrides the <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/valueOf"><code>Object.prototype.valueOf()</code></a> method.</dd>
</dl>

<h2 id="Usage_recommendations">Usage recommendations</h2>

<h3 id="Coercion">Coercion</h3>

<p>Because coercing between <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Number"><code>Number</code></a> and <code>BigInt</code> can lead to loss of precision, it is recommended to only use <code>BigInt</code> when values greater than 2<sup>53</sup> are reasonably expected and not to coerce between the two types.</p>

<h3 id="Cryptography">Cryptography</h3>

<p>The operations supported on <code>BigInt</code>s are not constant time. <code>BigInt</code> is therefore <a href="https://www.chosenplaintext.ca/articles/beginners-guide-constant-time-cryptography.html">unsuitable for use in cryptography</a>.</p>

<h3 id="Use_within_JSON">Use within JSON</h3>

<p>Using <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/JSON/stringify"><code>JSON.stringify()</code></a> with any <code>BigInt</code> value will raise a <code>TypeError</code> as <code>BigInt</code> values aren't serialized in JSON by default. However, you can implement your own <code>toJSON</code> method if needed:</p>

<pre class="brush: js notranslate">BigInt.prototype.toJSON = function() { return this.toString()  }</pre>

<p>Instead of throwing, <code>JSON.stringify</code> now produces a string like this:</p>

<pre class="brush: js notranslate">JSON.stringify(BigInt(1))
// '"1"'</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Calculating_Primes">Calculating Primes</h3>

<pre class="brush: js notranslate">// Returns true if passed BigInt is a prime number
function isPrime(p) {
  for (let i = 2n; i * i &lt;= p; i++) {
    if (p % i === 0n) return false;
  }
  return true
}

// Takes a BigInt as an argument, returns nth prime number as BigInt
function nthPrime(nth) {
  let maybePrime = 2n
  let prime = 0n

  while (nth &gt;= 0n) {
    if (isPrime(maybePrime)) {
      nth--
      prime = maybePrime
    }
    maybePrime++
  }

  return prime
}

nthPrime(20n)
// ↪ 73n</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("ESDraft", "#sec-bigint-objects", "<code>BigInt</code> objects")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a class="external" href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</div>

<p>{{Compat("javascript.builtins.BigInt")}}</p>

<h3 id="Implementation_Progress">Implementation Progress</h3>

<p>The following table provides a daily implementation status for this feature, because this feature has not yet reached cross-browser stability. The data is generated by running the relevant feature tests in <a href="https://github.com/tc39/test262">Test262</a>, the standard test suite of JavaScript, in the nightly build, or latest release of each browser's JavaScript engine.</p>

<div>{{EmbedTest262ReportResultsTable("BigInt")}}</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Number"><code>Number</code></a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Number/MAX_SAFE_INTEGER"><code>Number.MAX_SAFE_INTEGER</code></a></li>
</ul>
